;
;       USB Program Loader for PC-6001mkII
;       Part 2 version 0.1
;       by Koichi Nishida 2007
;
	ORG	4000H

	; load program

	; init 8255 
	LD	A,93H
	OUT	(0D3H),A

	; begin address
	CALL	READ
	LD	C,A
	CALL	READ
	LD	B,A
	; end address
	CALL	READ
	LD	L,A
	CALL	READ
	LD	H,A
	PUSH	BC
	OR	A
	SBC	HL,BC
	INC	HL
	; BC = length
	LD	B,H
	LD	C,L
	POP	HL
	; DE = start address
	CALL	READ
	LD	E,A
	CALL	READ
	LD	D,A
LDLP:
	CALL	READ
	PUSH	AF
	; write to the internal RAM
	LD	A,55H
	OUT	(0F2H),A
	POP	AF
	LD	(HL),A
	; and be back to the external RAM
	LD	A,59H
	OUT	(0F2H),A
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,LDLP

	; place a jump routine at stack pointer
	LD	H,0	; JP (DE)
	LD	L,D
	PUSH	HL
	LD	H,E
	LD	L,0C3H
	PUSH	HL
	; 4000H - 7FFFH = internal RAM
	LD	H,0F0H	; OUT (0F0H),A
	LD	L,0D3H
	PUSH	HL
	LD	H,011H	; LD A,11H
	LD	L,3EH
	PUSH	HL
	LD	H,0F2H	; OUT (0F2H),A
	LD	L,0D3H
	PUSH	HL
	LD	H,55H	; LD A,55H
	LD	L,3EH
	PUSH	HL
	LD	HL,0
	OR	A
	ADC	HL,SP
	POP	DE
	POP	DE
	POP	DE
	POP	DE
	POP	DE
	POP	DE
	JP	(HL)

	; read one byte
READ:
RDLP:
	IN	A,(0D2H)
	AND	01H
	JR	NZ,RDLP
	LD	A,08H
	OUT	(0D3H),A
	IN	A,(0D0H)
	PUSH	AF
	LD	A,09H
	OUT	(0D3H),A
	POP	AF
	RET

	; read address
RDWORD:
	CALL	READ
	LD	(HL),A	
	INC	HL
	CALL	READ
	LD	(HL),A	
	INC	HL
	RET
